Crypto++ 8.1 Free C++ class library of cryptographic schemes

Public Member Functions | List of all members
TruncatedHashTemplate< T > Class Template Reference

construct new HashModule with smaller DigestSize() from existing one More...

Inheritance diagram for TruncatedHashTemplate< T >:

## Public Member Functions
| TruncatedHashTemplate (T hm, unsigned int digestSize)
| TruncatedHashTemplate (const byte *key, size_t keyLength, unsigned int digestSize)
| TruncatedHashTemplate (size_t digestSize)
void | Restart ()
| Restart the hash. More...
void | Update (const byte *input, size_t length)
| Updates a hash with additional input. More...
unsigned int | DigestSize () const
| Provides the digest size of the hash. More...
void | TruncatedFinal (byte *digest, size_t digestSize)
| Computes the hash of the current message. More...
bool | TruncatedVerify (const byte *digest, size_t digestLength)
| Verifies the hash of the current message. More...
Public Member Functions inherited from HashTransformation
HashTransformation & | Ref ()
| Provides a reference to this object. More...
virtual byte * | CreateUpdateSpace (size_t &size)
| Request space which can be written into by the caller. More...
virtual void | Final (byte *digest)
| Computes the hash of the current message. More...
unsigned int | TagSize () const
| Provides the tag size of the hash. More...
virtual unsigned int | BlockSize () const
| Provides the block size of the compression function. More...
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this hash. More...
virtual unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance. More...
virtual void | CalculateDigest (byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | Verify (const byte *digest)
| Verifies the hash of the current message. More...
virtual bool | VerifyDigest (const byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
virtual void | CalculateTruncatedDigest (byte *digest, size_t digestSize, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | VerifyTruncatedDigest (const byte *digest, size_t digestLength, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
virtual std::string | AlgorithmName () const
| Provides the name of this algorithm. More...
virtual std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...

## Detailed Description

### template<class T>
class TruncatedHashTemplate< T >

construct new HashModule with smaller DigestSize() from existing one

Definition at line 23 of file trunhash.h.

## Member Function Documentation

## ◆ Restart()

template<class T >

void TruncatedHashTemplate< T >::Restart | ( |  | ) |
| inline virtual

Restart the hash.

Discards the current state, and restart for a new message

Reimplemented from HashTransformation.

Definition at line 33 of file trunhash.h.

## ◆ Update()

template<class T >

void TruncatedHashTemplate< T >::Update | ( | const byte * | input,
|  | size_t | length
| ) |  |
| inline virtual

Updates a hash with additional input.

Parameters

  input | the additional input as a buffer
  length | the size of the buffer, in bytes

Implements HashTransformation.

Definition at line 35 of file trunhash.h.

## ◆ DigestSize()

template<class T >

unsigned int TruncatedHashTemplate< T >::DigestSize | ( |  | ) | const
| inline virtual

Provides the digest size of the hash.

Returns
  the digest size of the hash.

Implements HashTransformation.

Definition at line 37 of file trunhash.h.

## ◆ TruncatedFinal()

template<class T >

void TruncatedHashTemplate< T >::TruncatedFinal | ( | byte * | digest,
|  | size_t | digestSize
| ) |  |
| inline virtual

Computes the hash of the current message.

Parameters

  digest | a pointer to the buffer to receive the hash
  digestSize | the size of the truncated digest, in bytes

TruncatedFinal() call Final() and then copies digestSize bytes to digest. The hash is restarted the hash for the next message.

Implements HashTransformation.

Definition at line 38 of file trunhash.h.

## ◆ TruncatedVerify()

template<class T >

bool TruncatedHashTemplate< T >::TruncatedVerify | ( | const byte * | digest,
|  | size_t | digestLength
| ) |  |
| inline virtual

Verifies the hash of the current message.

Parameters

  digest | a pointer to the buffer of an existing hash
  digestLength | the size of the truncated hash, in bytes

Returns
  `true` if the existing hash matches the computed hash, `false` otherwise

Exceptions

  ThrowIfInvalidTruncatedSize() | if digestLength exceeds DigestSize()

TruncatedVerify() is a truncated version of Verify(). It can operate on a buffer smaller than DigestSize(). However, digestLength cannot exceed DigestSize().

Verify() performs a bitwise compare on the buffers using VerifyBufsEqual(), which is a constant time comparison function. digestLength cannot exceed DigestSize().

TruncatedVerify() restarts the hash for the next message.

Reimplemented from HashTransformation.

Definition at line 40 of file trunhash.h.

The documentation for this class was generated from the following file:

- trunhash.h